"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.BaseModel = exports.IdModel = void 0;
var nanoid_1 = require("nanoid");
var type_graphql_1 = require("type-graphql");
var typeorm_1 = require("typeorm");
var decorators_1 = require("../decorators");
// type-graphql requires you set this as ObjectType for it's inheritance to work
var IdModel = /** @class */ (function () {
    function IdModel() {
    }
    IdModel.prototype.getId = function () {
        // If settings allow ID to be specified on create, use the specified ID
        return this.id || nanoid_1.nanoid();
    };
    IdModel.prototype.setId = function () {
        this.id = this.getId();
    };
    IdModel.prototype.getValue = function (field) {
        var self = this;
        if (self[field] instanceof Date) {
            return self[field].toISOString();
        }
        return self[field];
    };
    __decorate([
        decorators_1.PrimaryIdField({ filter: ['in'] }),
        __metadata("design:type", String)
    ], IdModel.prototype, "id", void 0);
    __decorate([
        typeorm_1.BeforeInsert(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], IdModel.prototype, "setId", null);
    IdModel = __decorate([
        type_graphql_1.ObjectType({ isAbstract: true })
    ], IdModel);
    return IdModel;
}());
exports.IdModel = IdModel;
// type-graphql requires you set this as ObjectType for it's inheritance to work
var BaseModel = /** @class */ (function (_super) {
    __extends(BaseModel, _super);
    function BaseModel() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    // In the base case, this will already be set by BaseModel
    // Setting this up so that child classes can override the default behavior
    // applying a separate owner than the logged in user
    // Example of where this would be used: an admin or superuser could create items and assign owners
    BaseModel.prototype.getOwnerId = function () {
        return this.ownerId;
    };
    BaseModel.prototype.setOwnerId = function () {
        this.ownerId = this.getOwnerId();
    };
    __decorate([
        decorators_1.CreatedAtField(),
        __metadata("design:type", Date)
    ], BaseModel.prototype, "createdAt", void 0);
    __decorate([
        decorators_1.CreatedByField(),
        __metadata("design:type", String)
    ], BaseModel.prototype, "createdById", void 0);
    __decorate([
        decorators_1.UpdatedAtField(),
        __metadata("design:type", Date)
    ], BaseModel.prototype, "updatedAt", void 0);
    __decorate([
        decorators_1.UpdatedByField(),
        __metadata("design:type", String)
    ], BaseModel.prototype, "updatedById", void 0);
    __decorate([
        decorators_1.DeletedAtField(),
        __metadata("design:type", Date)
    ], BaseModel.prototype, "deletedAt", void 0);
    __decorate([
        decorators_1.DeletedByField(),
        __metadata("design:type", String)
    ], BaseModel.prototype, "deletedById", void 0);
    __decorate([
        decorators_1.VersionField(),
        __metadata("design:type", Number)
    ], BaseModel.prototype, "version", void 0);
    __decorate([
        decorators_1.OwnerIdField(),
        __metadata("design:type", String)
    ], BaseModel.prototype, "ownerId", void 0);
    __decorate([
        typeorm_1.BeforeInsert(),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", []),
        __metadata("design:returntype", void 0)
    ], BaseModel.prototype, "setOwnerId", null);
    BaseModel = __decorate([
        type_graphql_1.ObjectType({ isAbstract: true })
    ], BaseModel);
    return BaseModel;
}(IdModel));
exports.BaseModel = BaseModel;
//# sourceMappingURL=BaseModel.js.map