"use strict";
// TODO-MVP: Add custom scalars such as graphql-iso-date
// import { GraphQLDate, GraphQLDateTime, GraphQLTime } from 'graphql-iso-date';
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CodeGenerator = void 0;
var graphql_1 = require("graphql");
var mkdirp = require("mkdirp");
var path = require("path");
var typedi_1 = require("typedi");
var _1 = require(".");
var decorators_1 = require("../decorators");
var gql_1 = require("../gql");
var schema_1 = require("../schema");
var tgql_1 = require("../tgql");
var utils_1 = require("../utils");
var CodeGenerator = /** @class */ (function () {
    function CodeGenerator(config, schemaGenerator) {
        this.config = config;
        this.schemaGenerator = schemaGenerator;
        this.generatedFolder = this.config.get('GENERATED_FOLDER');
        this.createGeneratedFolder();
        this.schemaBuilder = new schema_1.SchemaBuilder({
            resolvers: this.config.get('RESOLVERS_PATH'),
            validate: this.config.get('VALIDATE_RESOLVERS') === 'true'
        });
        tgql_1.loadFromGlobArray(this.config.get('DB_ENTITIES'));
    }
    CodeGenerator.prototype.createGeneratedFolder = function () {
        return mkdirp.sync(this.generatedFolder);
    };
    CodeGenerator.prototype.generate = function (options) {
        if (options === void 0) { options = { generateBinding: false }; }
        return __awaiter(this, void 0, void 0, function () {
            var error_1;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 7, , 8]);
                        return [4 /*yield*/, this.writeGeneratedIndexFile()];
                    case 1:
                        _a.sent();
                        return [4 /*yield*/, this.writeGeneratedTSTypes()];
                    case 2:
                        _a.sent();
                        return [4 /*yield*/, this.writeOrmConfig()];
                    case 3:
                        _a.sent();
                        return [4 /*yield*/, this.writeSchemaFile()];
                    case 4:
                        _a.sent();
                        if (!options.generateBinding) return [3 /*break*/, 6];
                        return [4 /*yield*/, this.generateBinding()];
                    case 5:
                        _a.sent();
                        _a.label = 6;
                    case 6: return [3 /*break*/, 8];
                    case 7:
                        error_1 = _a.sent();
                        _1.logger.error(error_1);
                        decorators_1.debug(error_1); // this is required to log when run in a separate project
                        return [3 /*break*/, 8];
                    case 8: return [2 /*return*/];
                }
            });
        });
    };
    CodeGenerator.prototype.generateBinding = function () {
        return __awaiter(this, void 0, void 0, function () {
            var schemaFilePath, outputBindingPath;
            return __generator(this, function (_a) {
                schemaFilePath = path.join(this.generatedFolder, 'schema.graphql');
                outputBindingPath = path.join(this.generatedFolder, 'binding.ts');
                return [2 /*return*/, gql_1.generateBindingFile(schemaFilePath, outputBindingPath)];
            });
        });
    };
    // @debug
    CodeGenerator.prototype.buildGraphQLSchema = function () {
        return __awaiter(this, void 0, void 0, function () {
            var _a;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        if (!!this.schema) return [3 /*break*/, 2];
                        _a = this;
                        return [4 /*yield*/, this.schemaBuilder.build({
                                authChecker: tgql_1.authChecker
                            })];
                    case 1:
                        _a.schema = _b.sent();
                        _b.label = 2;
                    case 2: return [2 /*return*/, this.schema];
                }
            });
        });
    };
    CodeGenerator.prototype.writeGeneratedTSTypes = function () {
        return __awaiter(this, void 0, void 0, function () {
            var generatedTSTypes;
            return __generator(this, function (_a) {
                generatedTSTypes = this.getGeneratedTypes();
                return [2 /*return*/, this.writeToGeneratedFolder('classes.ts', generatedTSTypes)];
            });
        });
    };
    // @debug
    CodeGenerator.prototype.getGeneratedTypes = function () {
        return this.schemaGenerator.generate(this.config.get('MODULE_IMPORT_PATH'));
    };
    CodeGenerator.prototype.writeSchemaFile = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.buildGraphQLSchema()];
                    case 1:
                        _a.sent();
                        return [2 /*return*/, this.writeToGeneratedFolder('schema.graphql', graphql_1.printSchema(this.schema))];
                }
            });
        });
    };
    // Write an index file that loads `classes` so that you can just import `../../generated`
    // in your resolvers
    CodeGenerator.prototype.writeGeneratedIndexFile = function () {
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                return [2 /*return*/, this.writeToGeneratedFolder('index.ts', "export * from './classes';")];
            });
        });
    };
    CodeGenerator.prototype.writeOrmConfig = function () {
        return __awaiter(this, void 0, void 0, function () {
            var contents;
            return __generator(this, function (_a) {
                contents = "import {Container} from 'typedi';\nimport { Database } from '" + this.config.get('MODULE_IMPORT_PATH') + "';\nContainer.import([Database]);\nconst database = Container.get('Database') as Database;\n\nmodule.exports = database.getBaseConfig();    \n";
                return [2 /*return*/, this.writeToGeneratedFolder('ormconfig.ts', contents)];
            });
        });
    };
    CodeGenerator.prototype.writeToGeneratedFolder = function (filename, contents) {
        return __awaiter(this, void 0, void 0, function () {
            var x;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        decorators_1.debug('writeToGeneratedFolder:' + filename + ':start');
                        return [4 /*yield*/, utils_1.writeFilePromise(path.join(this.generatedFolder, filename), contents, {
                                encoding: 'utf8',
                                flag: 'w'
                            })];
                    case 1:
                        x = _a.sent();
                        decorators_1.debug('writeToGeneratedFolder:' + filename + ':end');
                        return [2 /*return*/, x];
                }
            });
        });
    };
    __decorate([
        decorators_1.debug('warthog:code-generator'),
        __metadata("design:type", Function),
        __metadata("design:paramtypes", [Object]),
        __metadata("design:returntype", Promise)
    ], CodeGenerator.prototype, "generate", null);
    CodeGenerator = __decorate([
        typedi_1.Service('CodeGenerator'),
        __param(0, typedi_1.Inject('Config')),
        __param(1, typedi_1.Inject('SchemaGenerator')),
        __metadata("design:paramtypes", [_1.Config,
            schema_1.SchemaGenerator])
    ], CodeGenerator);
    return CodeGenerator;
}());
exports.CodeGenerator = CodeGenerator;
//# sourceMappingURL=CodeGenerator.js.map