"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CreatedAtField = void 0;
var type_graphql_1 = require("type-graphql");
var typeorm_1 = require("typeorm");
var utils_1 = require("../utils");
var getCombinedDecorator_1 = require("./getCombinedDecorator");
function CreatedAtField(options) {
    if (options === void 0) { options = {}; }
    var factories = getCombinedDecorator_1.getCombinedDecorator({
        fieldType: 'datetime',
        dbType: 'timestamptz',
        gqlFieldType: type_graphql_1.GraphQLISODateTime,
        warthogColumnMeta: __assign({ specialType: 'created-at', readonly: true }, options),
        dbDecorator: typeorm_1.CreateDateColumn
    });
    return utils_1.composeMethodDecorators.apply(void 0, factories);
}
exports.CreatedAtField = CreatedAtField;
//# sourceMappingURL=CreatedAtField.js.map