"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PrimaryIdField = void 0;
var type_graphql_1 = require("type-graphql");
var typeorm_1 = require("typeorm");
var utils_1 = require("../utils");
var getCombinedDecorator_1 = require("./getCombinedDecorator");
function PrimaryIdField(options) {
    if (options === void 0) { options = {}; }
    if (typeof options.filter === 'undefined') {
        options.filter = ['eq', 'in'];
    }
    var factories = getCombinedDecorator_1.getCombinedDecorator({
        fieldType: 'id',
        gqlFieldType: type_graphql_1.ID,
        warthogColumnMeta: __assign({ specialType: 'primary', unique: true, readonly: true }, options),
        dbDecorator: typeorm_1.PrimaryColumn
    });
    return utils_1.composeMethodDecorators.apply(void 0, factories);
}
exports.PrimaryIdField = PrimaryIdField;
//# sourceMappingURL=PrimaryIdField.js.map