"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
var path = require("path");
var typedi_1 = require("typedi");
var core_1 = require("../../core");
var schema_1 = require("../../schema");
var torm_1 = require("../../torm");
var server_vars_1 = require("../server-vars");
var my_base_model_model_1 = require("./my-base-model.model");
var MockConfig = /** @class */ (function () {
    function MockConfig() {
        var standardVars = server_vars_1.getStandardEnvironmentVariables();
        this.config = __assign(__assign({}, standardVars), { FILTER_BY_DEFAULT: 'false', GENERATED_FOLDER: path.join(__dirname, 'generated'), DB_ENTITIES: [path.join(__dirname + "/**/*.model.ts")], RESOLVERS_PATH: [path.join(__dirname + "/**/*.resolver.ts")], VALIDATE_RESOLVERS: false, MODULE_IMPORT_PATH: '../../../' });
    }
    MockConfig.prototype.get = function (key) {
        if (typeof this.config[key] !== 'undefined') {
            return this.config[key];
        }
        return this.config["WARTHOG_" + key];
    };
    MockConfig = __decorate([
        typedi_1.Service(),
        __metadata("design:paramtypes", [])
    ], MockConfig);
    return MockConfig;
}());
describe('MyBaseModel', function () {
    var service; //  MyBaseModelTestService;
    var connection;
    // Make sure to clean up server
    beforeAll(function (done) { return __awaiter(void 0, void 0, void 0, function () {
        var config, database, schemaGenerator, codeGenerator;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    config = new MockConfig();
                    typedi_1.default.set('Config', config);
                    database = core_1.getContainer(torm_1.Database);
                    return [4 /*yield*/, database.createDBConnection()];
                case 1:
                    connection = _a.sent();
                    service = core_1.getContainer(my_base_model_model_1.MyBaseModelTestService);
                    schemaGenerator = new schema_1.SchemaGenerator(config);
                    codeGenerator = new core_1.CodeGenerator(config, schemaGenerator);
                    return [4 /*yield*/, codeGenerator.generate({ generateBinding: false })];
                case 2:
                    _a.sent();
                    done();
                    return [2 /*return*/];
            }
        });
    }); });
    // Make sure to clean up server
    afterAll(function (done) { return __awaiter(void 0, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, connection.close()];
                case 1:
                    _a.sent();
                    done();
                    return [2 /*return*/];
            }
        });
    }); });
    test('standard fields are automatically set on create', function () { return __awaiter(void 0, void 0, void 0, function () {
        var userId, testModel;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    userId = 'u_00123';
                    return [4 /*yield*/, service.create({ stringField: 'foo' }, userId)];
                case 1:
                    testModel = _a.sent();
                    expect(testModel.createdById).toBe(userId);
                    expect(testModel.ownerId).toBe(userId);
                    expect(testModel.updatedById).toBeNull();
                    expect(testModel.deletedById).toBeNull();
                    expect(testModel.createdAt instanceof Date).toBeTruthy();
                    expect(testModel.updatedAt instanceof Date).toBeTruthy();
                    expect(testModel.deletedAt instanceof Date).toBeFalsy();
                    expect(testModel.deletedAt).toBeNull();
                    expect(testModel.version).toBe(1);
                    expect(testModel.stringField).toBe('foo');
                    return [2 /*return*/];
            }
        });
    }); });
    test('standard fields are automatically set on update', function () { return __awaiter(void 0, void 0, void 0, function () {
        var userId, testModel;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    userId = 'u_00123';
                    return [4 /*yield*/, service.create({ stringField: 'foo' }, userId)];
                case 1:
                    testModel = _a.sent();
                    expect(testModel.createdById).toBe(userId);
                    expect(testModel.ownerId).toBe(userId);
                    expect(testModel.updatedById).toBeNull();
                    expect(testModel.createdAt instanceof Date).toBeTruthy();
                    expect(testModel.updatedAt instanceof Date).toBeTruthy();
                    expect(testModel.deletedAt instanceof Date).toBeFalsy();
                    expect(testModel.deletedAt).toBeNull();
                    expect(testModel.version).toBe(1);
                    expect(testModel.stringField).toBe('foo');
                    return [2 /*return*/];
            }
        });
    }); });
});
//# sourceMappingURL=my-base-model.test.js.map