"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isError = exports.callAPIError = exports.callAPISuccess = exports.callAPI = void 0;
var flatted_1 = require("flatted");
var graphql_1 = require("graphql");
var __1 = require("../");
// Calls our API returning the error object if encountered
// Use this if you want to test errors
function callAPI(promise) {
    return __awaiter(this, void 0, void 0, function () {
        var error_1;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    _a.trys.push([0, 2, , 3]);
                    return [4 /*yield*/, promise];
                case 1: return [2 /*return*/, (_a.sent())];
                case 2:
                    error_1 = _a.sent();
                    return [2 /*return*/, __1.getBindingError(error_1)];
                case 3: return [2 /*return*/];
            }
        });
    });
}
exports.callAPI = callAPI;
// Calls our API, throwing an error if encountered
// Use this if a failed API call should fail our test
// This allows us to write more succinct code in our tests because we don't need to
// Type guard around potentially failed error reponses
function callAPISuccess(promise) {
    return __awaiter(this, void 0, void 0, function () {
        var response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, callAPI(promise)];
                case 1:
                    response = _a.sent();
                    if (isError(response)) {
                        throw new Error(toErrorString(response, 'expected a successful API call'));
                    }
                    return [2 /*return*/, response];
            }
        });
    });
}
exports.callAPISuccess = callAPISuccess;
// Calls our API, throwing an error if encountered
// Use this if a failed API call should fail our test
// This allows us to write more succinct code in our tests because we don't need to
// Type guard around potentially failed error reponses
function callAPIError(promise) {
    return __awaiter(this, void 0, void 0, function () {
        var response;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4 /*yield*/, callAPI(promise)];
                case 1:
                    response = _a.sent();
                    if (!isError(response)) {
                        throw new Error(toErrorString(response, 'expected a failed API call'));
                    }
                    // The binding coerces errors of type GraphQL Error into an actual error object
                    // instead of the raw JSON, so we need special handling
                    if (response instanceof graphql_1.GraphQLError) {
                        return [2 /*return*/, {
                                message: response.message,
                                extensions: {
                                    code: 'GRAPHQL_ERROR'
                                }
                            }];
                    }
                    return [2 /*return*/, response];
            }
        });
    });
}
exports.callAPIError = callAPIError;
// Checks to see if API response is an error by going through extensions node
function isError(response) {
    // TODO: for some reason the binding returns GraphQLErrors differently
    // Hide this in the future
    if (response instanceof graphql_1.GraphQLError) {
        return true;
    }
    var extensions = response.extensions;
    return extensions && extensions.code !== undefined;
}
exports.isError = isError;
function toErrorString(obj, msg) {
    var error;
    if (typeof obj === 'string') {
        error = msg + ": " + obj;
    }
    else {
        error = msg + ": " + flatted_1.stringify(obj);
    }
    console.error();
    return error;
}
//# sourceMappingURL=utils.js.map