"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.loadFromGlobArray = exports.loadFromGlobString = exports.findFileNamesFromGlob = void 0;
var glob = require("glob");
function findFileNamesFromGlob(globString) {
    return glob.sync(globString);
}
exports.findFileNamesFromGlob = findFileNamesFromGlob;
function loadFromGlobString(globString) {
    var filePaths = findFileNamesFromGlob(globString);
    return filePaths.map(function (fileName) { return require(fileName); });
}
exports.loadFromGlobString = loadFromGlobString;
function loadFromGlobArray(globs) {
    var results = [];
    if (!globs || !globs.length) {
        return [];
    }
    globs.forEach(function (globString) {
        if (typeof globString === 'string') {
            results = __spreadArrays(results, loadFromGlobString(globString));
        }
    });
    return results;
}
exports.loadFromGlobArray = loadFromGlobArray;
//# sourceMappingURL=loadGlobs.js.map