"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Database = void 0;
var typedi_1 = require("typedi");
var typeorm_1 = require("typeorm");
var core_1 = require("../core/");
var SnakeNamingStrategy_1 = require("./SnakeNamingStrategy");
var Database = /** @class */ (function () {
    function Database(config) {
        this.config = config;
    }
    Database.prototype.getBaseConfig = function () {
        return {
            cli: {
                entitiesDir: this.config.get('DB_ENTITIES_DIR'),
                migrationsDir: this.config.get('DB_MIGRATIONS_DIR'),
                subscribersDir: this.config.get('DB_SUBSCRIBERS_DIR')
            },
            database: this.config.get('DB_DATABASE'),
            entities: this.config.get('DB_ENTITIES'),
            host: this.config.get('DB_HOST'),
            logger: this.config.get('DB_LOGGER'),
            logging: this.config.get('DB_LOGGING'),
            migrations: this.config.get('DB_MIGRATIONS'),
            namingStrategy: new SnakeNamingStrategy_1.SnakeNamingStrategy(),
            password: this.config.get('DB_PASSWORD'),
            port: parseInt(this.config.get('DB_PORT') || '', 10),
            subscribers: this.config.get('DB_SUBSCRIBERS'),
            synchronize: this.config.get('DB_SYNCHRONIZE') === 'true',
            type: this.config.get('DB_CONNECTION'),
            username: this.config.get('DB_USERNAME')
        };
    };
    // Note: all DB options should be specified by environment variables
    // Either using TYPEORM_<variable> or WARTHOG_DB_<variable>
    Database.prototype.createDBConnection = function (dbOptions) {
        if (dbOptions === void 0) { dbOptions = {}; }
        return __awaiter(this, void 0, void 0, function () {
            var config;
            return __generator(this, function (_a) {
                config = __assign(__assign({}, this.getBaseConfig()), dbOptions);
                if (!config.database) {
                    throw new Error("createConnection: 'database' is required");
                }
                // Logger.debug('createDBConnection', config);
                return [2 /*return*/, typeorm_1.createConnection(config)]; // TODO: fix any.  It is complaining about `type`
            });
        });
    };
    Database = __decorate([
        typedi_1.Service('Database'),
        __param(0, typedi_1.Inject('Config')),
        __metadata("design:paramtypes", [core_1.Config])
    ], Database);
    return Database;
}());
exports.Database = Database;
//# sourceMappingURL=database.service.js.map