import { IDType } from '../core';
export declare abstract class IdModel {
    id: IDType;
    getId(): string;
    setId(): void;
    getValue(field: string): string | number;
}
export declare class BaseModel extends IdModel {
    createdAt: Date;
    createdById: IDType;
    updatedAt: Date;
    updatedById: IDType;
    deletedAt: Date;
    deletedById?: IDType;
    version: number;
    ownerId: IDType;
    getOwnerId(): string;
    setOwnerId(): void;
}
