import { GraphQLSchema } from 'graphql';
import * as mkdirp from 'mkdirp';
import { Config } from '.';
import { SchemaBuilder, SchemaGenerator } from '../schema';
interface GenerateOptions {
    generateBinding?: boolean;
}
export declare class CodeGenerator {
    readonly config: Config;
    readonly schemaGenerator: SchemaGenerator;
    generatedFolder: string;
    schema?: GraphQLSchema;
    schemaBuilder: SchemaBuilder;
    constructor(config: Config, schemaGenerator: SchemaGenerator);
    createGeneratedFolder(): mkdirp.Made;
    generate(options?: GenerateOptions): Promise<void>;
    private generateBinding;
    private buildGraphQLSchema;
    private writeGeneratedTSTypes;
    private getGeneratedTypes;
    private writeSchemaFile;
    private writeGeneratedIndexFile;
    private writeOrmConfig;
    private writeToGeneratedFolder;
}
export {};
