import { Container } from 'typedi';
import { Logger } from '../core';
interface ConfigOptions {
    dotenvPath?: string;
    configSearchPath?: string;
    container?: Container;
    logger?: Logger;
}
declare type ConfigObj = any;
declare type NodeENV = 'development' | 'test' | 'production' | 'none';
export declare class Config {
    private options;
    readonly WARTHOG_ENV_PREFIX = "WARTHOG_";
    readonly TYPEORM_ENV_PREFIX = "TYPEORM_";
    readonly WARTHOG_DB_ENV_PREFIX = "WARTHOG_DB_";
    defaults: Record<string, any>;
    devDefaults: Record<string, any>;
    prodDefaults: Record<string, any>;
    testDefaults: Record<string, any>;
    PROJECT_ROOT: string;
    container: Container;
    logger?: Logger;
    NODE_ENV?: NodeENV;
    config: ConfigObj;
    constructor(options?: ConfigOptions);
    determineNodeEnv(dotenvPath: string): NodeENV;
    loadDotenvFiles(dotenvPath: string): void;
    loadSync(): Config;
    finalizeConfig(config: ConfigObj): any;
    getApiBaseUrl(): any;
    getApiUrl(path?: string): string;
    getApiPort(): any;
    get(key?: string): any;
    warthogEnvVariables(): any;
    warthogDBEnvVariables(): any;
    typeORMEnvVariables(): any;
    translateEnvVar(key: string, value: string): string | string[];
    envVarsByPrefix(prefix: string): any;
    typeORMToWarthogEnvVariables(): any;
    writeWarthogEnvVars(): void;
    validateEntryExists(key: string): void;
    loadStaticConfigSync(): {
        [key: string]: any;
    };
    private loadStaticConfigFileSync;
}
export {};
