import { GraphQLScalarType, GraphQLSchema } from 'graphql';
import { PubSubEngine, PubSubOptions } from 'graphql-subscriptions';
import { AuthChecker } from 'type-graphql';
import { Middleware } from 'type-graphql/dist/interfaces/Middleware';
import { ScalarsTypeMap } from 'type-graphql/dist/schema/build-context';
import { Config } from '../core';
interface BuildOptions<C> {
    authChecker?: AuthChecker<C>;
    middlewares?: Middleware[];
    pubSub?: PubSubEngine | PubSubOptions;
    scalars?: ScalarsTypeMap[];
}
interface SchemaBuilderOptions {
    resolvers: (string | Function)[];
    validate?: boolean;
}
export declare class SchemaBuilder {
    private options;
    config: Config;
    constructor(options: SchemaBuilderOptions);
    build<C>(options: BuildOptions<C>): Promise<GraphQLSchema>;
    loadScalarFiles(): {
        type: any;
        scalar: GraphQLScalarType;
    }[];
}
export {};
