import * as prettier from 'prettier';
import { Config } from '../core';
import { ColumnMetadata, MetadataStorage, ModelMetadata } from '../metadata';
export declare class SchemaGenerator {
    readonly config: Config;
    metadata: MetadataStorage;
    constructor(config: Config);
    generate(warthogImportPath?: string): string;
    getColumnsForModel(model: ModelMetadata): ColumnMetadata[];
    filenameToImportPath(filename: string): string;
    columnToGraphQLDataType(column: ColumnMetadata): string;
    columnToTypeScriptType(column: ColumnMetadata): string;
    generateEnumMapImports(): string[];
    generateClassImports(): string[];
    entityToWhereUniqueInput(model: ModelMetadata): string;
    entityToCreateInput(model: ModelMetadata): string;
    entityToUpdateInput(model: ModelMetadata): string;
    entityToUpdateInputArgs(model: ModelMetadata): string;
    columnToTypes(column: ColumnMetadata): {
        graphqlType: string | import("graphql").GraphQLScalarType;
        tsType: string;
    };
    entityToWhereInput(model: ModelMetadata): string;
    entityToWhereArgs(model: ModelMetadata): string;
    entityToCreateManyArgs(model: ModelMetadata): string;
    entityToOrderByEnum(model: ModelMetadata): string;
    columnRequiresExplicitGQLType(column: ColumnMetadata): boolean | import("graphql").GraphQLEnumType;
    format(code: string, options?: prettier.Options): string;
}
