import { JsonObject, PaginationArgs, DateOnlyString, DateTimeString } from '../../';
import { StringEnum } from "../modules/kitchen-sink/kitchen-sink.model";
export declare enum ApiOnlyOrderByEnum {
    id_ASC = "id_ASC",
    id_DESC = "id_DESC",
    name_ASC = "name_ASC",
    name_DESC = "name_DESC"
}
export declare class ApiOnlyWhereInput {
    id_eq?: string;
    id_in?: string[];
    name_eq?: string;
    name_contains?: string;
    name_startsWith?: string;
    name_endsWith?: string;
    name_in?: string[];
}
export declare class ApiOnlyWhereUniqueInput {
    id?: string;
}
export declare class ApiOnlyCreateInput {
    name: string;
}
export declare class ApiOnlyUpdateInput {
    name?: string;
}
export declare class ApiOnlyWhereArgs extends PaginationArgs {
    where?: ApiOnlyWhereInput;
    orderBy?: ApiOnlyOrderByEnum;
}
export declare class ApiOnlyCreateManyArgs {
    data: ApiOnlyCreateInput[];
}
export declare class ApiOnlyUpdateArgs {
    data: ApiOnlyUpdateInput;
    where: ApiOnlyWhereUniqueInput;
}
export declare enum KitchenSinkOrderByEnum {
    id_ASC = "id_ASC",
    id_DESC = "id_DESC",
    stringField_ASC = "stringField_ASC",
    stringField_DESC = "stringField_DESC",
    nullableStringField_ASC = "nullableStringField_ASC",
    nullableStringField_DESC = "nullableStringField_DESC",
    dateField_ASC = "dateField_ASC",
    dateField_DESC = "dateField_DESC",
    dateOnlyField_ASC = "dateOnlyField_ASC",
    dateOnlyField_DESC = "dateOnlyField_DESC",
    dateTimeField_ASC = "dateTimeField_ASC",
    dateTimeField_DESC = "dateTimeField_DESC",
    emailField_ASC = "emailField_ASC",
    emailField_DESC = "emailField_DESC",
    integerField_ASC = "integerField_ASC",
    integerField_DESC = "integerField_DESC",
    booleanField_ASC = "booleanField_ASC",
    booleanField_DESC = "booleanField_DESC",
    floatField_ASC = "floatField_ASC",
    floatField_DESC = "floatField_DESC",
    computedColumn_ASC = "computedColumn_ASC",
    computedColumn_DESC = "computedColumn_DESC",
    idField_ASC = "idField_ASC",
    idField_DESC = "idField_DESC",
    stringEnumField_ASC = "stringEnumField_ASC",
    stringEnumField_DESC = "stringEnumField_DESC",
    numericField_ASC = "numericField_ASC",
    numericField_DESC = "numericField_DESC",
    numericFieldCustomPrecisionScale_ASC = "numericFieldCustomPrecisionScale_ASC",
    numericFieldCustomPrecisionScale_DESC = "numericFieldCustomPrecisionScale_DESC",
    noFilterField_ASC = "noFilterField_ASC",
    noFilterField_DESC = "noFilterField_DESC",
    characterField_ASC = "characterField_ASC",
    characterField_DESC = "characterField_DESC",
    readonlyField_ASC = "readonlyField_ASC",
    readonlyField_DESC = "readonlyField_DESC",
    apiOnlyField_ASC = "apiOnlyField_ASC",
    apiOnlyField_DESC = "apiOnlyField_DESC",
    createdAt_ASC = "createdAt_ASC",
    createdAt_DESC = "createdAt_DESC",
    createdById_ASC = "createdById_ASC",
    createdById_DESC = "createdById_DESC",
    updatedAt_ASC = "updatedAt_ASC",
    updatedAt_DESC = "updatedAt_DESC",
    updatedById_ASC = "updatedById_ASC",
    updatedById_DESC = "updatedById_DESC",
    deletedAt_ASC = "deletedAt_ASC",
    deletedAt_DESC = "deletedAt_DESC",
    deletedById_ASC = "deletedById_ASC",
    deletedById_DESC = "deletedById_DESC",
    version_ASC = "version_ASC",
    version_DESC = "version_DESC",
    ownerId_ASC = "ownerId_ASC",
    ownerId_DESC = "ownerId_DESC"
}
export declare class KitchenSinkWhereInput {
    id_eq?: string;
    id_in?: string[];
    stringField_eq?: string;
    stringField_contains?: string;
    stringField_startsWith?: string;
    stringField_endsWith?: string;
    stringField_in?: string[];
    nullableStringField_eq?: string;
    nullableStringField_contains?: string;
    nullableStringField_startsWith?: string;
    nullableStringField_endsWith?: string;
    nullableStringField_in?: string[];
    dateField_eq?: Date;
    dateField_lt?: Date;
    dateField_lte?: Date;
    dateField_gt?: Date;
    dateField_gte?: Date;
    dateOnlyField_eq?: DateOnlyString;
    dateOnlyField_lt?: DateOnlyString;
    dateOnlyField_lte?: DateOnlyString;
    dateOnlyField_gt?: DateOnlyString;
    dateOnlyField_gte?: DateOnlyString;
    dateTimeField_eq?: DateTimeString;
    dateTimeField_lt?: DateTimeString;
    dateTimeField_lte?: DateTimeString;
    dateTimeField_gt?: DateTimeString;
    dateTimeField_gte?: DateTimeString;
    emailField_eq?: string;
    emailField_contains?: string;
    emailField_startsWith?: string;
    emailField_endsWith?: string;
    emailField_in?: string[];
    integerField_eq?: number;
    integerField_gt?: number;
    integerField_gte?: number;
    integerField_lt?: number;
    integerField_lte?: number;
    integerField_in?: number[];
    booleanField_eq?: Boolean;
    booleanField_in?: Boolean[];
    floatField_eq?: number;
    floatField_gt?: number;
    floatField_gte?: number;
    floatField_lt?: number;
    floatField_lte?: number;
    floatField_in?: number[];
    computedColumn_eq?: string;
    computedColumn_contains?: string;
    computedColumn_startsWith?: string;
    computedColumn_endsWith?: string;
    computedColumn_in?: string[];
    jsonField_json?: JsonObject;
    idField_eq?: string;
    idField_in?: string[];
    stringEnumField_eq?: StringEnum;
    stringEnumField_in?: StringEnum[];
    numericField_eq?: number;
    numericField_gt?: number;
    numericField_gte?: number;
    numericField_lt?: number;
    numericField_lte?: number;
    numericField_in?: number[];
    numericFieldCustomPrecisionScale_eq?: number;
    numericFieldCustomPrecisionScale_gt?: number;
    numericFieldCustomPrecisionScale_gte?: number;
    numericFieldCustomPrecisionScale_lt?: number;
    numericFieldCustomPrecisionScale_lte?: number;
    numericFieldCustomPrecisionScale_in?: number[];
    noSortField_eq?: string;
    noSortField_contains?: string;
    noSortField_startsWith?: string;
    noSortField_endsWith?: string;
    noSortField_in?: string[];
    stringFieldFilterEqContains_eq?: string;
    stringFieldFilterEqContains_contains?: string;
    intFieldFilterLteGte_gte?: number;
    intFieldFilterLteGte_lte?: number;
    characterField_eq?: string;
    characterField_contains?: string;
    characterField_startsWith?: string;
    characterField_endsWith?: string;
    characterField_in?: string[];
    readonlyField_eq?: string;
    readonlyField_contains?: string;
    readonlyField_startsWith?: string;
    readonlyField_endsWith?: string;
    readonlyField_in?: string[];
    apiOnlyField_eq?: string;
    apiOnlyField_contains?: string;
    apiOnlyField_startsWith?: string;
    apiOnlyField_endsWith?: string;
    apiOnlyField_in?: string[];
    arrayOfStrings_containsAll?: [string];
    arrayOfStrings_containsNone?: [string];
    arrayOfStrings_containsAny?: [string];
    arrayOfInts_containsAll?: [number];
    arrayOfInts_containsNone?: [number];
    arrayOfInts_containsAny?: [number];
    createdAt_eq?: DateTimeString;
    createdAt_lt?: DateTimeString;
    createdAt_lte?: DateTimeString;
    createdAt_gt?: DateTimeString;
    createdAt_gte?: DateTimeString;
    createdById_eq?: string;
    createdById_in?: string[];
    updatedAt_eq?: DateTimeString;
    updatedAt_lt?: DateTimeString;
    updatedAt_lte?: DateTimeString;
    updatedAt_gt?: DateTimeString;
    updatedAt_gte?: DateTimeString;
    updatedById_eq?: string;
    updatedById_in?: string[];
    deletedAt_all?: Boolean;
    deletedAt_eq?: DateTimeString;
    deletedAt_lt?: DateTimeString;
    deletedAt_lte?: DateTimeString;
    deletedAt_gt?: DateTimeString;
    deletedAt_gte?: DateTimeString;
    deletedById_eq?: string;
    deletedById_in?: string[];
    version_eq?: number;
    version_gt?: number;
    version_gte?: number;
    version_lt?: number;
    version_lte?: number;
    version_in?: number[];
    ownerId_eq?: string;
    ownerId_in?: string[];
}
export declare class KitchenSinkWhereUniqueInput {
    id?: string;
    emailField?: string;
}
export declare class KitchenSinkCreateInput {
    stringField: string;
    textField?: string;
    nullableStringField?: string;
    dateField?: Date;
    dateOnlyField?: DateOnlyString;
    dateTimeField?: DateTimeString;
    emailField: string;
    integerField: number;
    booleanField: boolean;
    floatField: number;
    jsonField?: JsonObject;
    idField?: string;
    stringEnumField?: StringEnum;
    numericField?: number;
    numericFieldCustomPrecisionScale?: number;
    noFilterField?: string;
    noSortField?: string;
    noFilterOrSortField?: string;
    stringFieldFilterEqContains?: string;
    intFieldFilterLteGte?: number;
    characterField?: string;
    customTextFieldNoSortOrFilter?: string;
    customFieldArrayColumn?: string[];
    writeonlyField?: string;
    apiOnlyField?: string;
    arrayOfStrings?: string[];
    arrayOfInts?: number[];
}
export declare class KitchenSinkUpdateInput {
    stringField?: string;
    textField?: string;
    nullableStringField?: string;
    dateField?: Date;
    dateOnlyField?: DateOnlyString;
    dateTimeField?: DateTimeString;
    emailField?: string;
    integerField?: number;
    booleanField?: boolean;
    floatField?: number;
    jsonField?: JsonObject;
    idField?: string;
    stringEnumField?: StringEnum;
    numericField?: number;
    numericFieldCustomPrecisionScale?: number;
    noFilterField?: string;
    noSortField?: string;
    noFilterOrSortField?: string;
    stringFieldFilterEqContains?: string;
    intFieldFilterLteGte?: number;
    characterField?: string;
    customTextFieldNoSortOrFilter?: string;
    customFieldArrayColumn?: string[];
    writeonlyField?: string;
    apiOnlyField?: string;
    arrayOfStrings?: string[];
    arrayOfInts?: number[];
}
export declare class KitchenSinkWhereArgs extends PaginationArgs {
    where?: KitchenSinkWhereInput;
    orderBy?: KitchenSinkOrderByEnum;
}
export declare class KitchenSinkCreateManyArgs {
    data: KitchenSinkCreateInput[];
}
export declare class KitchenSinkUpdateArgs {
    data: KitchenSinkUpdateInput;
    where: KitchenSinkWhereUniqueInput;
}
export declare enum DishOrderByEnum {
    createdAt_ASC = "createdAt_ASC",
    createdAt_DESC = "createdAt_DESC",
    name_ASC = "name_ASC",
    name_DESC = "name_DESC",
    stringEnumField_ASC = "stringEnumField_ASC",
    stringEnumField_DESC = "stringEnumField_DESC",
    kitchenSinkId_ASC = "kitchenSinkId_ASC",
    kitchenSinkId_DESC = "kitchenSinkId_DESC"
}
export declare class DishWhereInput {
    id_in?: string[];
    createdAt_eq?: DateTimeString;
    createdAt_lt?: DateTimeString;
    createdAt_lte?: DateTimeString;
    createdAt_gt?: DateTimeString;
    createdAt_gte?: DateTimeString;
    name_eq?: string;
    name_contains?: string;
    name_startsWith?: string;
    name_endsWith?: string;
    name_in?: string[];
    stringEnumField_eq?: StringEnum;
    stringEnumField_in?: StringEnum[];
    kitchenSinkId_eq?: string;
    kitchenSinkId_in?: string[];
}
export declare class DishWhereUniqueInput {
    id?: string;
}
export declare class DishCreateInput {
    name: string;
    stringEnumField?: StringEnum;
    kitchenSinkId: string;
}
export declare class DishUpdateInput {
    name?: string;
    stringEnumField?: StringEnum;
    kitchenSinkId?: string;
}
export declare class DishWhereArgs extends PaginationArgs {
    where?: DishWhereInput;
    orderBy?: DishOrderByEnum;
}
export declare class DishCreateManyArgs {
    data: DishCreateInput[];
}
export declare class DishUpdateArgs {
    data: DishUpdateInput;
    where: DishWhereUniqueInput;
}
