import { IDType } from 'core';
import { BaseModel, DateOnlyString, DateTimeString, JsonObject } from '../../../';
import { Dish } from '../dish/dish.model';
import { StringEnum } from '../shared';
export { StringEnum };
export declare class KitchenSink extends BaseModel {
    id: IDType;
    stringField?: string;
    textField?: string;
    nullableStringField?: string;
    dateField?: Date;
    dateOnlyField?: DateOnlyString;
    dateTimeField?: DateTimeString;
    emailField: string;
    integerField?: number;
    booleanField?: boolean;
    floatField?: number;
    computedColumn?: string;
    jsonField?: JsonObject;
    idField?: string;
    stringEnumField?: StringEnum;
    dishes: Dish[];
    dbOnlyColumn?: string;
    numericField?: number;
    numericFieldCustomPrecisionScale?: number;
    noFilterField?: string;
    noSortField?: string;
    noFilterOrSortField?: string;
    stringFieldFilterEqContains?: string;
    intFieldFilterLteGte?: number;
    characterField?: string;
    customTextFieldNoSortOrFilter?: string;
    customFieldArrayColumn?: string[];
    customTextFieldReadOnly?: string;
    readonlyField?: string;
    writeonlyField?: string;
    dbOnlyField?: string;
    apiOnlyField?: string;
    arrayOfStrings: string[];
    arrayOfInts: number[];
}
