export interface APIError {
    message: string;
    path?: string[];
    extensions: {
        code: string;
        exception?: {
            stacktrace: string[];
        };
    };
}
export declare function callAPI<E>(promise: Promise<E>): Promise<E | APIError>;
export declare function callAPISuccess<E>(promise: Promise<E>): Promise<E>;
export declare function callAPIError<E>(promise: Promise<E>): Promise<APIError>;
export declare function isError<E>(response: E | APIError): response is APIError;
