import { ConnectionOptions } from 'typeorm';
import { Config } from '../core/';
import { SnakeNamingStrategy } from './SnakeNamingStrategy';
export declare type ColumnType = IntColumnType | StringColumnType | FloatColumnType | NumericColumnType | JSONColumnType | BooleanColumnType | 'money' | 'citext' | 'hstore' | 'bytea' | 'bit' | 'varbit' | 'bit varying' | 'timetz' | 'timestamptz' | 'timestamp' | 'timestamp without time zone' | 'timestamp with time zone' | 'date' | 'time' | 'time without time zone' | 'time with time zone' | 'interval' | 'enum' | 'point' | 'line' | 'lseg' | 'box' | 'path' | 'polygon' | 'circle' | 'cidr' | 'inet' | 'macaddr' | 'tsvector' | 'tsquery' | 'uuid' | 'xml' | 'int4range' | 'int8range' | 'numrange' | 'tsrange' | 'tstzrange' | 'daterange' | 'geometry' | 'geography';
export declare type StringColumnType = 'varchar' | 'character varying' | 'character' | 'char' | 'text';
export declare type IntColumnType = 'int' | 'int2' | 'int4' | 'int8' | 'smallint' | 'integer' | 'bigint';
export declare type FloatColumnType = 'float' | 'float4' | 'float8' | 'real' | 'double precision';
export declare type NumericColumnType = 'numeric' | 'decimal';
export declare type MoneyColumnType = 'money';
export declare type JSONColumnType = 'json' | 'jsonb';
export declare type BooleanColumnType = 'bool' | 'boolean';
export declare class Database {
    readonly config: Config;
    constructor(config: Config);
    getBaseConfig(): {
        cli: {
            entitiesDir: any;
            migrationsDir: any;
            subscribersDir: any;
        };
        database: any;
        entities: any;
        host: any;
        logger: any;
        logging: any;
        migrations: any;
        namingStrategy: SnakeNamingStrategy;
        password: any;
        port: number;
        subscribers: any;
        synchronize: boolean;
        type: any;
        username: any;
    };
    createDBConnection(dbOptions?: Partial<ConnectionOptions>): Promise<import("typeorm").Connection>;
}
